<?php defined('SYSPATH') OR die('No direct access allowed.');
/**
 * Cloudinfo widget
 *
 * @package    NINJA
 * @author     op5 AB
 * @license    GPL
 */
class Cloudinfo_Widget extends widget_Core {

	public function __construct()
	{
		parent::__construct();

		# needed to figure out path to widget
		$this->set_widget_name(__CLASS__, basename(__FILE__));
	}

	public function index($arguments=false, $master=false)
	{
		# required to enable us to assign the correct
		# variables to the calling controller
		$this->master_obj = $master;

		# fetch widget view path
		$view_path = $this->view_path('view');

		$widget_id = $this->widgetname;
		$refresh_rate = 60;
		if (isset($arguments['refresh_interval'])) {
			$refresh_rate = $arguments['refresh_interval'];
		}

		# Apply users custom name or default if not set
		$title = isset($arguments['widget_title'])
			? $arguments['widget_title']
			: _('Cloud Information');

		# let view template know if wrapping div should be hidden or not
		$ajax_call = request::is_ajax() ? true : false;

		/**
		*	Actual widget logic goes here
		*/
		$error = false;
		$blog_url = "http://www.op5.com/rss/cloud.html";
		$rawFeed = @file_get_contents($blog_url) or $error = true;

		if (!$error) {
			$xml = new SimpleXmlElement($rawFeed);

			$channel = array();
			$channel['title']       = $xml->channel->title;
			$channel['link']        = $xml->channel->link;
			$channel['description'] = $xml->channel->description;
			$channel['pubDate']     = $xml->pubDate;
			$channel['timestamp']   = strtotime($xml->pubDate);
			$channel['generator']   = $xml->generator;
			$channel['language']    = $xml->language;

			foreach ($xml->channel->item as $item)
			{
			        $article = array();
			        $article['channel'] = $item->blog;
			        $article['title'] = $item->title;
			        $article['link']= $item->link;
			        $article['comments'] = $item->comments;
			        $article['pubDate'] = $item->pubDate;
			        $article['timestamp'] = strtotime($item->pubDate);
			        $article['description'] = (string) trim($item->description);
			        $article['isPermaLink'] = $item->guid['isPermaLink'];

			        // add this article to the list
			        $articles[$article['timestamp']] = $article;
			}

			$i = 0;
			$content = '';
        	foreach ($articles as $blog) {
				$content.= "<tr id=\"support-news-feed$i\">\n";
				$content.= "<td class=\"dark\">".html::image($this->widget_full_path.'/images/news.png')."</td>";
				$content.= "\t<td><strong><a href=\"" . $blog['link'][0] . "\" target=\"_new\">" . $blog['title'][0] . "</a></strong><br />\n";
				$content.= "\t" . date(nagstat::date_format(), $blog['timestamp']) . "\n";
				//$content.= "\t" . $blog['description'] . "\n";
				$content.= "</td>\n";
				$content.= "</tr>";
				$i++;
			}
		} else {
			$links = array(
				'**RSS feed could not be found!!**' => 'http://www.op5.com',
				'Link to op5 homepage' => 'http://www.op5.com',
				'Link to op5 Support' => 'http://www.op5.com/support',

			);

			$content = '';
			$i = 0;
			foreach ($links as $name => $link ) {
				$content.= "<tr id=\"cloud-link$i\">\n";
				$content.= "<td class=\"dark\">".html::image($this->widget_full_path.'/images/link.png')."</td>";
				$content.= "\t<td><strong><a href=\"" . $link . "\" target=\"_new\">" . $name . "</a></strong><br />\n";
				$content.= "</td>\n";
				$content.= "</tr>";
				$i++;
			}
		}

		# fetch widget content
		require_once($view_path);

		if(request::is_ajax()) {
			# output widget content
			echo json::encode( $this->output());
		} else {
			# set required extra resources
			$this->js = array('/js/cloudinfo');
			$this->css = array('/css/cloudinfo');

			# call parent helper to assign all
			# variables to master controller
			return $this->fetch();
		}
	}
}
